<template>
  <div class="cart-panel-time-selector" @click.prevent.stop>
    <div class="cart-panel-time-selector-conatiner">
      <date-selector
        @close="$emit('close')"
        @dateChanged="date => $emit('dateChanged', date)"
        @timeChanged="time => $emit('timeChanged', time)"
        :time="time"
        :times="times"
        :date="date"
        :dates="dates"
      />
      <div
        class="cart-panel-time-selector-desc"
        v-html="$t(`${scopeCartPanel}.timeSelectorDesc`)"
      ></div>
    </div>
  </div>
</template>

<script>
import DateSelector from "@/components/Group/DateSelector";

export default {
  components: {
    DateSelector
  },

  props: {
    time: {
      type: String,
      required: true
    },
    times: {
      type: Array,
      required: true
    },
    date: {
      type: Date,
      required: true
    },
    dates: {
      type: Array,
      required: true
    },
    scopeCartPanel: {
      type: String,
      default: "preorderCartPanel"
    }
  },

  mounted() {
    this.close = () => this.$emit("close");
    setTimeout(() => {
      window.addEventListener("click", this.close);
    }, 100);
  },

  destroyed() {
    window.removeEventListener("click", this.close);
  }
};
</script>

<style lang="scss" scoped>
// vue 的 scoped 有 bug，class 寫比較完全
.cart-panel-time-selector {
  z-index: 1;
  position: absolute;
  left: -1px;
  top: 100%;
  margin-top: 20px;
  width: 100%;
  border-radius: 4px;
  background: $color-white;
  border: 1px $color-white solid;
  box-shadow: 0 4px 18px rgba(0, 0, 0, 0.12);
}

.cart-panel-time-selector-conatiner {
  padding: 15px 10px 20px;
}

.cart-panel-time-selector-desc {
  font-size: 12px;
  color: $color-primary-grey;
  margin-top: 10px;
}
</style>
